
import 'package:flutter/material.dart';
import 'package:stripe_package/flutterwave222/core/flutterwave.dart';
import 'package:stripe_package/flutterwave222/utils/flutterwave_currency.dart';
import 'package:stripe_package/history/history.dart';
import 'package:uuid/uuid.dart';


class AccountPay extends StatefulWidget {
  AccountPay({
    Key? key,
    required this.id,
    required this.fullName,
    required this.amount,
    required this.accountnumber,
    required this.datetime,
    required this.currency,
  }) : super(key: key);
  final String id;
  final String fullName;
  final String amount;
  final String accountnumber;
  final String datetime;
  final String currency;


  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<AccountPay> {
  final formKey = GlobalKey<FormState>();
  final fullNameController = TextEditingController();
  final amountController = TextEditingController();
  final currencyController = TextEditingController();
  final narrationController = TextEditingController();
  final publicKeyController = TextEditingController();
  final encryptionKeyController = TextEditingController();
  final emailController = TextEditingController();
  final phoneNumberController = TextEditingController();

  String selectedCurrency = "";

  bool isDebug = true;
  bool _isShow = true;

  // String? selectedValue;



  @override
  Widget build(BuildContext context) {
    this.currencyController.text = this.selectedCurrency;


    return Scaffold(
      appBar: AppBar(
        leading: IconButton(icon: Icon(Icons.arrow_back),onPressed: (){Navigator.of(context, rootNavigator: true).pop(context);} ),
      ),
      body: Container(
        width: double.infinity,
        margin: EdgeInsets.fromLTRB(20, 10, 20, 10),
        child: Form(
          key: this.formKey,
          child: ListView(
            children: <Widget>[


              Container(
                margin: EdgeInsets.fromLTRB(0, 10, 0, 10),
                child: TextFormField(
                  controller: this.fullNameController,
                  keyboardType: TextInputType.name,
                  textInputAction: TextInputAction.next,
                  style: TextStyle(color: Colors.black),
                  decoration: InputDecoration(
                      label: Text("Full Name")
                  ),
                  validator: (value) =>
                  value!.isNotEmpty ? null : "Full Name is required",
                ),
              ),

              Container(
                margin: EdgeInsets.fromLTRB(0, 10, 0, 10),
                child: TextFormField(

                  controller: this.amountController,
                  textInputAction: TextInputAction.next,

                  keyboardType: TextInputType.number,
                  style: TextStyle(color: Colors.black),
                  decoration: InputDecoration(label: Text("amount"), prefix: Text("XAF ")),
                  validator: (value) =>
                  value!.isNotEmpty ? null : "Amount is required",
                ),
              ),


              // DropdownButtonFormField2(
              //   decoration: InputDecoration(
              //     //Add isDense true and zero Padding.
              //     //Add Horizontal padding using buttonPadding and Vertical padding by increasing buttonHeight instead of add Padding here so that The whole TextField Button become clickable, and also the dropdown menu open under The whole TextField Button.
              //     isDense: true,
              //     contentPadding: EdgeInsets.only(right: 20),
              //     // border: OutlineInputBorder(
              //     //   borderRadius: BorderRadius.circular(15),
              //     // ),
              //     //Add more decoration as you want here
              //     //Add label If you want but add hint outside the decoration to be aligned in the button perfectly.
              //   ),
              //   isExpanded: true,
              //   hint: const Text(
              //     'Currency',
              //     style: TextStyle(fontSize: 16),
              //   ),
              //   icon: const Icon(
              //     Icons.arrow_drop_down,
              //     color: Colors.black45,
              //   ),
              //   iconSize: 30,
              //   buttonHeight: 53,
              //   buttonWidth: 140,
              //   // buttonPadding: const EdgeInsets.only(left: 20, right: 10),
              //   // dropdownDecoration: BoxDecoration(
              //     // borderRadius: BorderRadius.only(b)
              //   // ),
              //   items: currencies
              //       .map((item) =>
              //       DropdownMenuItem<String>(
              //         value: item,
              //         child: Text(
              //           item,
              //           style: const TextStyle(
              //             fontSize: 14,
              //           ),
              //         ),
              //       ))
              //       .toList(),
              //   validator: (value) {
              //     if (value == null) {
              //       return 'Currency is required';
              //     }
              //   },
              //   onChanged: (value) {
              //     setState(() {
              //       selectedCurrency =  value.toString();
              //     });
              //   },
              //   onSaved: (value) {
              //     selectedCurrency = value.toString();
              //   },
              // ),



              // Container(
              //   margin: EdgeInsets.fromLTRB(0, 10, 0, 10),
              //   child: TextFormField(
              //     controller: this.currencyController,
              //     textInputAction: TextInputAction.next,
              //     style: TextStyle(color: Colors.black),
              //     readOnly: true,
              //     // onTap: this._openBottomSheet,
              //
              //     decoration: InputDecoration(
              //       // hintText: "Currency",
              //       prefix: Text("XAF")
              //     ),
              //     validator: (value) =>
              //         value!.isNotEmpty ? null : "Currency is required",
              //   ),
              // ),
              // Container(
              //   margin: EdgeInsets.fromLTRB(0, 20, 0, 10),
              //   child: TextFormField(
              //     controller: this.publicKeyController,
              //     textInputAction: TextInputAction.next,
              //     style: TextStyle(color: Colors.black),
              //     obscureText: true,
              //     decoration: InputDecoration(
              //       hintText: "Public Key",
              //     ),
              //   ),
              // ),
              // Container(
              //   margin: EdgeInsets.fromLTRB(0, 20, 0, 10),
              //   child: TextFormField(
              //     controller: this.encryptionKeyController,
              //     textInputAction: TextInputAction.next,
              //     style: TextStyle(color: Colors.black),
              //     obscureText: true,
              //     decoration: InputDecoration(
              //       hintText: "Encryption Key",
              //     ),
              //   ),
              // ),


              Container(
                margin: EdgeInsets.fromLTRB(0, 10, 0, 10),
                child: TextFormField(
                  keyboardType: TextInputType.emailAddress,
                  controller: this.emailController,
                  textInputAction: TextInputAction.next,
                  style: TextStyle(color: Colors.black),
                  decoration: InputDecoration(
                      label: Text("Email")
                  ),
                  validator: (value) =>
                  value!.isNotEmpty ? null : "Email is required",
                ),
              ),
              Container(
                margin: EdgeInsets.fromLTRB(0, 10, 0, 10),
                child: TextFormField(
                  controller: this.phoneNumberController,
                  textInputAction: TextInputAction.next,
                  style: TextStyle(color: Colors.black),
                  decoration: InputDecoration(
                      label: Text("Phone Number")
                  ),
                  validator: (value) =>
                  value!.isNotEmpty ? null : "Phone Number is required",
                ),
              ),
              // Container(
              //   width: double.infinity,
              //   margin: EdgeInsets.fromLTRB(0, 20, 0, 10),
              //   child: Row(
              //     // mainAxisAlignment: MainAxisAlignment.spaceBetween,
              //     children: [
              //       Text("Use Debug"),
              //       Switch(
              //         onChanged: (value) => {
              //           setState(() {
              //             isDebug = value;
              //           })
              //         },
              //         value: this.isDebug,
              //       ),
              //     ],
              //   ),
              // ),
              Container(
                width: double.infinity,
                height: 50,
                margin: EdgeInsets.fromLTRB(0, 10, 0, 10),
                child: ElevatedButton(
                  onPressed: this._onPressed,
                  // color: Colors.blue,
                  child: Text(
                    "Make Payment",
                    style: TextStyle(color: Colors.white),
                  ),
                ),
              ),

              // MaterialColor(primary value: Color(0xff9e9e9e))
              widget.id != "" ?  Visibility(
                visible: _isShow,
                child: Center(
                  child: SizedBox(
                    width: 250,
                    child: Card(
                      elevation: 5,

                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: [
                          Column(
                            children: [
                              // Image.asset("assets/96237-success.gif",height: 60,width: 60,),
                              Text("Payment Successfull",style: TextStyle(fontWeight: FontWeight.w700,color: Colors.green,fontSize: 17),),
                              Text(" ID - ${widget.id} \n Name - ${widget.fullName} \n Amount - ${widget.currency+" "+ widget.amount} \n Account Number - ${widget.accountnumber} \n Date - ${widget.datetime} \n"),
                            ],
                          ),



                          InkWell(
                              onTap: (){   setState(
                                      () {
                                    _isShow = !_isShow;
                                  });},
                              child: Icon(Icons.close,size: 15,)),
                        ],
                      ),
                    ),
                  ),
                ),
              ):Container(),

              ElevatedButton(

                onPressed: () {
                  Navigator.push(
                    context,
                    MaterialPageRoute(builder: (context) => const HistoryAppp()),
                  );
                },
                child: const Text('History'),
              ),



            ],
          ),
        ),
      ), // This trailing comma makes auto-formatting nicer for build methods.
    );
  }




  void onGooglePayResult(paymentResult) {
    debugPrint(paymentResult.toString());
  }



  _onPressed() {
    if (this.formKey.currentState!.validate()) {
      this._handlePaymentInitialization();
    }
  }

  _handlePaymentInitialization() async {
    final flutterwave = Flutterwave.forUIPayment(
      flwRef: Uuid().v1(),
      amount: amountController.text,
      currency: "XAF",
      context: this.context,
      publicKey: "FLWPUBK_TEST-2e7df31b04f9c3bec0b298f13639f983-X",
      encryptionKey: "FLWSECK_TEST083ebde67d8b",
      email: emailController.text,
      fullName: fullNameController.text,
      txRef: Uuid().v4(),
      narration: "Example Project",
      isDebugMode: this.isDebug,
      phoneNumber: phoneNumberController.text,
      acceptAccountPayment: true, customer: fullNameController.text,

      // acceptCardPayment: true,
      // acceptUSSDPayment: true,
      // acceptBankTransfer:true
    );

    final response = await flutterwave.initializeForUiPayments();
    if (response == null) {
      print("Transaction Failed");
    } else {
      if (response.status == "success"||mounted) {
        setState(() {
          // id = response.data!.id;
          // amountt = response.data!.chargedAmount;
        });
        print(response.data);
        print(response.message);
        print(response.data!.id);
      } else {
        print(response.message);
      }
      // final response = await flutterwave.initializeForUiPayments();
      // if (response != null) {
      //   this.showLoading(response.data!.status!);
      //   print("===============>success");
      // } else {
      //   this.showLoading("No Response!");
      // }
    }
  }

  // void dropDown(){
  //
  //
  //   // currencies
  //   //     .map((item) =>
  //   // DropdownMenuItem<String>(
  //   //   value: item,
  //   //   child: Text(
  //   //     item,
  //   //     style: const TextStyle(
  //   //       fontSize: 14,
  //   //     ),
  //   //   ),
  //   // ) ) .toList();
  // }


  void _openBottomSheet() {
    showModalBottomSheet(
        context: this.context,
        builder: (context) {
          return this._getCurrency();
        });
  }

  final currencies = [
    FlutterwaveCurrency.UGX,
    // FlutterwaveCurrency.GHS,
    // FlutterwaveCurrency.NGN,
    FlutterwaveCurrency.RWF,
    // FlutterwaveCurrency.KES,
    FlutterwaveCurrency.XAF,
    FlutterwaveCurrency.XOF,
    // FlutterwaveCurrency.ZMW
  ];


  Widget _getCurrency() {
    final currencies = [
      FlutterwaveCurrency.UGX,
      // FlutterwaveCurrency.GHS,
      // FlutterwaveCurrency.NGN,
      FlutterwaveCurrency.RWF,
      // FlutterwaveCurrency.KES,
      FlutterwaveCurrency.XAF,
      FlutterwaveCurrency.XOF,
      // FlutterwaveCurrency.ZMW
    ];
    return Container(
      height: 250,
      margin: EdgeInsets.fromLTRB(0, 10, 0, 0),
      color: Colors.white,
      child: ListView(
        children: currencies
            .map((currency) => ListTile(
          onTap: () => {this._handleCurrencyTap(currency)},
          title: Column(
            children: [
              Text(
                currency,
                textAlign: TextAlign.start,
                style: TextStyle(color: Colors.black),
              ),
              SizedBox(height: 4),
              Divider(height: 1)
            ],
          ),
        ))
            .toList(),
      ),
    );
  }

  _handleCurrencyTap(String currency) {
    this.setState(() {
      this.selectedCurrency = currency;
      this.currencyController.text = currency;
    });
    Navigator.pop(this.context);
  }

  Future<void> showLoading(String message) {
    return showDialog(
      context: this.context,
      barrierDismissible: false,
      builder: (BuildContext context) {
        return AlertDialog(
          content: Container(
            margin: EdgeInsets.fromLTRB(30, 20, 30, 20),
            width: double.infinity,
            height: 50,
            child: Text(message),
          ),
        );
      },
    );
  }
}

